Redmine - Patch #36503

Reduce extra queries in IssueQuery.default
2022-01-23 08:29 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Performance Estimated time: 0.00 hour
Target version:

Description
The attached patch reduces the total number of SQL queries during the execution of IssueQuery.default.

No default queries in any levels:

before:

UserPreference Load (0.2ms) SELECT "user_preferences".* FROM "user_preferences" WHERE "user_pre

ferences"."user_id" = ? LIMIT ? [["user_id", 1], ["LIMIT", 1]1]
L app/models/user.rb:394:in “pref'
IssueQuery Load (0.lms) SELECT "queries".* FROM "queries" WHERE "queries"."type" = ? AND "queri

es"."id" IS NULL LIMIT ? [["type", "IssueQuery"], ["LIMIT", 1]]

L app/models/issue_query.rb:83:in ‘default'

Setting Load (0.1lms) SELECT "settings".* FROM "settings" WHERE "settings"."name" = ? ORDER BY "
settings"."id" DESC LIMIT °? [["name", "default_issue_query"], ["LIMIT", 1]]

L app/models/setting.rb:360:in " find_or_default'

IssueQuery Load (0.lms) SELECT "queries".* FROM "queries" WHERE "queries"."type" = ? AND "queri
es"."id" = ? LIMIT *? [["type", "IssueQuery"], ["id", nil], ["LIMIT", 1]]

L app/models/issue_query.rb:86:in “default'

after:

UserPreference Load (0.1lms) SELECT "user_preferences".* FROM "user_preferences" WHERE "user_pre

ferences"."user_id" = ? LIMIT ? [["user_id", 1], ["LIMIT", 1]1]
L app/models/user.rb:394:in “pref'
Setting Load (0.lms) SELECT "settings".* FROM "settings" WHERE "settings"."name" = ? ORDER BY "

settings"."id" DESC LIMIT °? [["name", "default_issue_query"], ["LIMIT", 1]]
> app/models/setting.rb:360:in “find_or_default'

A project-level default query defined:

before:

UserPreference Load (0.2ms) SELECT "user_preferences".* FROM "user_preferences" WHERE "user_pre

ferences"."user_id" = ? LIMIT ? [["user_id", 1], ["LIMIT", 1]]
L app/models/user.rb:394:in ‘pref'
IssueQuery Load (0.2ms) SELECT "queries".* FROM "queries" WHERE "queries"."type" = ? AND "queri

es"."id" IS NULL LIMIT °? [["type", "IssueQuery"], ["LIMIT", 1]]

L app/models/issue_query.rb:83:in “default'

IssueQuery Load (0.2ms) SELECT "queries".* FROM "queries" WHERE "queries"."type" = ? AND "queri
es"."id" = ? LIMIT ? [["type", "IssueQuery"], ["id", 4], ["LIMIT", 1]]

> app/models/issue_query.rb:85:in “default’

after:

UserPreference Load (0.2ms) SELECT "user_preferences".* FROM "user_preferences" WHERE "user_pre

ferences"."user_id" = ? LIMIT ? [["user_id", 1], ["LIMIT", 1]]
L app/models/user.rb:394:in “pref'
IssueQuery Load (0.2ms) SELECT "queries".* FROM "queries" WHERE "queries"."type" = ? AND "queri
es"."id" = ? LIMIT ? [["type", "IssueQuery"]l, ["id", 4], ["LIMIT", 11]
L app/models/issue_query.rb:87:in “default'

Related issues:
Related to Redmine - Feature #7360: Issue custom query: default query per ins... Closed 2011-01-18
Copied to Redmine - Patch #37135: Reduce extra queries in ProjectQuery.default Closed

Associated revisions

Revision 21387 - 2022-01-23 12:55 - Go MAEDA
Reduce extra database queries in IssueQuery.default (#7360, #36503).

Revision 21480 - 2022-03-20 22:38 - Marius BALTEANU
Do not fire a query to get user default query when user has no default query set (#36503).
Patch by Dmitry Makurin.

Revision 21484 - 2022-03-21 07:00 - Go MAEDA
Reverts r21480 (#36503).

Revision 21485 - 2022-03-21 07:10 - Go MAEDA

Do not fire a query to get user default query when user has no default query set (#36503).

Patch by Dmitry Makurin.

History

#1 - 2022-01-23 08:47 - Go MAEDA

- Tracker changed from Defect to Patch

#2 - 2022-01-23 12:24 - Go MAEDA

- Related to Feature #7360: Issue custom query: default query per instance, project and user added

#3 - 2022-01-23 12:56 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch as a part of #7360.

#4 - 2022-02-01 11:14 - Dmitry Makurin

Isn't there https://www.redmine.org/projects/redmine/repository/entry/trunk/app/models/issue_query.rb#L 83 also supposed to be a present? at the end
of second condition?

If (query_id = user.pref.default_issue_query) equals to "" the query stil fires.

diff --git a/app/models/issue_query.rb b/app/models/issue_query.rb
index 5a3eld4474..e7aclc821 100644
--— a/app/models/issue_query.rb
+++ b/app/models/issue_query.rb
@@ -80,7 +80,7 Q@ class IssueQuery < Query
def self.default (project: nil, user: User.current)

query = nil

# user default
= if user&.logged? && (query_id = user.pref.default_issue_query)
+ if useré&.logged? && (query_id = user.pref.default_issue_query) .present?

query = find_by(id: query_id)
end
# project default

#5 - 2022-03-19 09:00 - Marius BALTEANU

- Status changed from Closed to Reopened

#6 - 2022-03-20 22:39 - Marius BALTEANU

- Status changed from Reopened to Closed
https://www.redmine.org/issues/7360
https://www.redmine.org/projects/redmine/repository/entry/trunk/app/models/issue_query.rb#L83

Dmitry Makurin wrote:

Isn't there https://www.redmine.org/projects/redmine/repository/entry/trunk/app/models/issue_query.rb#L 83 also supposed to be a present? at
the end of second condition?

If (query_id = user.pref.default_issue_query) equals to "" the query stil fires.
[-]
Committed the patch, thanks for pointing this out.

#7 - 2022-05-18 17:26 - Dmitry Makurin
- Copied to Patch #37135: Reduce extra queries in ProjectQuery.default added

Files
